/*******************************************************************************
AnalogDebounced Arduino library http://libahunt.ee/analogdebounced
by Anna Jõgi a.k.a Libahunt
Public domain

For
- using one analog input for multiple (2-5) buttons input
- doing so in a debounced way, because analog transitions are 
especially prone to give faulty results on single reading.
*******************************************************************************/
#ifndef ANALOGDEBOUNCED_H
#define ANALOGDEBOUNCED_H

#include "Arduino.h"

class AnalogDebounced {

  public:
  
    AnalogDebounced(int pinNumber, unsigned long debounceDelay, int numberOfButtons, int *valueMappings);
		//numberOfButtons has to be declared as const
    int dbRead();
		
	private:

		int pin;
		int buttons;
    unsigned long dbDelay;
		int mappings[10];
    int lastDbState;
    unsigned long lastDbTime;
    int value;
		int i;

		int readMapped(int pin);

};
#endif
